﻿/*
 * Author: Adrian Posor
 * Year: 2009
 * License: GPL
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Desktop_Sharing_2009
{
    public partial class Form2 : Form
    {
        //public System.Net.Sockets.Socket workerSocket;
        //public System.Net.Sockets.Socket ClientSocketListener;
        private MainWindow mainwindow;
        private delegate void FunctionPointer();
        private delegate void FunctionPointer2(object obj);
        private delegate void FunctionPointer3(String str);

        public Form2(MainWindow mw)
        {
            InitializeComponent();
            mainwindow = mw;
        }

        public AxRDPCOMAPILib.AxRDPViewer getViewer()
        {
            return axRDPViewer1;
        }

        private void OnControlLevelChanged(object sender, AxRDPCOMAPILib._IRDPSessionEvents_OnControlLevelChangeRequestEvent e)
        {
            string message = "The control level was set to ";
            string caption = "Desktop Sharing 2009";
            MessageBoxButtons buttons = MessageBoxButtons.OK;


            // Displays the MessageBox.

            MessageBox.Show(this, message, caption, buttons,
            MessageBoxIcon.Question, MessageBoxDefaultButton.Button1);
        }

        private void OnConnectionTerminated(object sender, AxRDPCOMAPILib._IRDPSessionEvents_OnConnectionTerminatedEvent e)
        {
            string message = "The connection to the server has been closed.";
            string caption = "Desktop Sharing 2009";
            MessageBoxButtons buttons = MessageBoxButtons.OK;


            // Displays the MessageBox.

            MessageBox.Show(this, message, caption, buttons,
            MessageBoxIcon.Information, MessageBoxDefaultButton.Button1);

            FunctionPointer fp = new FunctionPointer(mainwindow.viewerEnableConnectButtons);
            mainwindow.Invoke(fp);

            FunctionPointer csl = new FunctionPointer(mainwindow.startClientSocketListener);
            mainwindow.Invoke(csl);

            this.Hide();
        }

        private void OnError(object sender, AxRDPCOMAPILib._IRDPSessionEvents_OnErrorEvent e)
        {
            string message = "The following error occurred: " + e.ToString();
            string caption = "Desktop Sharing 2009";
            MessageBoxButtons buttons = MessageBoxButtons.OK;


            // Displays the MessageBox.

            MessageBox.Show(this, message, caption, buttons,
            MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
        }    

        private void OnFormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.WindowState = FormWindowState.Minimized;
        }

        private void OnConnectionEstablished(object sender, EventArgs e)
        {
            mainwindow.try_reverse_connection = false;

            try
            {
                mainwindow.ClientConnectViaIPSocket.Shutdown(System.Net.Sockets.SocketShutdown.Both);
                mainwindow.ClientConnectViaIPSocket.Close();
            }
            catch (NullReferenceException) { }
            catch (ObjectDisposedException) { }
            //textBox1.Text += Environment.NewLine + "ClientConnectViaIPSocket closed.";

            try
            {
                mainwindow.WorkerSocketClient.Shutdown(System.Net.Sockets.SocketShutdown.Both);
                mainwindow.WorkerSocketClient.Close();
            }
            catch (ObjectDisposedException) { }
            catch (NullReferenceException) { }
            catch (System.Net.Sockets.SocketException) { }

            try
            {
                mainwindow.ClientSocketListener.Close();
            }
            catch (ObjectDisposedException) { }
            catch (NullReferenceException) { }
            catch (System.Net.Sockets.SocketException) { }
        }

        private void OnAttendeeConnectedViewer(object sender, AxRDPCOMAPILib._IRDPSessionEvents_OnAttendeeConnectedEvent e)
        {
            FunctionPointer2 fp = new FunctionPointer2(mainwindow.addParticipantToList);
            mainwindow.Invoke(fp, new Object[] {e.pAttendee});
            //mainwindow.addParticipantToList(e.pAttendee);
        }

        private void OnAttendeeDisconnectedViewer(object sender, AxRDPCOMAPILib._IRDPSessionEvents_OnAttendeeDisconnectedEvent e)
        {
            FunctionPointer2 fp = new FunctionPointer2(mainwindow.removeParticipantFromList);
            mainwindow.Invoke(fp, new Object[] {e});
            //mainwindow.removeParticipantFromList(e);
        }

        private void OnConnectionFailedViewer(object sender, EventArgs e)
        {
            if (mainwindow.try_reverse_connection)
            {
                mainwindow.Invoke(mainwindow.write, new String[] { "Connection failed. Trying reverse connection..." });
                FunctionPointer rc = new FunctionPointer(mainwindow.initiateReverseConnection);
                mainwindow.Invoke(rc);
            }
            else
            {
                FunctionPointer fp = new FunctionPointer(mainwindow.viewerEnableConnectButtons);
                mainwindow.Invoke(fp);

                mainwindow.Invoke(mainwindow.write, new String[] { "Connection to Server failed." });
                this.Hide();
            }
        }
 
    }
}
